blob: cee8d2f7aea2a32b5a35acf88c474ff1d32866fe [file] [log] [blame]
Benedikt Böhm00ccea62010-01-26 12:39:36 +01001#
Vincent Driessen6c2d30b2010-01-26 22:18:36 +01002# git-flow -- A collection of Git extensions to provide high-level
3# repository operations for Vincent Driessen's branching model.
Benedikt Böhm00ccea62010-01-26 12:39:36 +01004#
5# Original blog post presenting this model is found at:
6# http://nvie.com/archives/323
7#
8# Feel free to contribute to this project at:
9# http://github.com/nvie/gitflow
10#
11# Copyright (c) 2010 by Vincent Driessen
12# Copyright (c) 2010 by Benedikt Böhm
13#
14
Vincent Driessenab3dc492010-01-29 12:35:49 +010015VERSION_PREFIX=$(git config --get gitflow.prefix.versiontag)
Benedikt Böhm49dd62b2010-01-28 00:51:15 +010016PREFIX=$(git config --get gitflow.prefix.hotfix || echo hotfix/)
17
Benedikt Böhm00ccea62010-01-26 12:39:36 +010018usage() {
Vincent Driessen3c337fb2010-02-04 11:30:18 +010019 echo "usage: git flow hotfix [list] [-v]"
Vincent Driessen186d2b52010-01-27 23:48:39 +010020 echo " git flow hotfix start <version> [<base>]"
Vincent Driessen010252a2010-02-04 10:31:29 +010021 echo " git flow hotfix finish <version>"
Benedikt Böhm00ccea62010-01-26 12:39:36 +010022}
23
Vincent Driessen186d2b52010-01-27 23:48:39 +010024cmd_default() {
Vincent Driessenb866b012010-01-28 01:01:53 +010025 cmd_list "$@"
Benedikt Böhm00ccea62010-01-26 12:39:36 +010026}
27
Vincent Driessenb866b012010-01-28 01:01:53 +010028cmd_list() {
Vincent Driessen3c337fb2010-02-04 11:30:18 +010029 DEFINE_boolean verbose false 'verbose (more) output' v
30 parse_args "$@"
31
Vincent Driessen27592dd2010-02-06 14:45:39 +010032 typeset hotfix_branches
33 typeset current_branch
34 typeset short_names
Vincent Driessenc5fcc012010-02-10 00:18:08 +010035 hotfix_branches=$(echo "$LOCAL_BRANCHES" | grep "^$PREFIX")
Vincent Driessen27592dd2010-02-06 14:45:39 +010036 if [ -z "$hotfix_branches" ]; then
Vincent Driessen186d2b52010-01-27 23:48:39 +010037 warn "No hotfix branches exist."
38 exit 0
39 fi
Vincent Driessen27592dd2010-02-06 14:45:39 +010040 current_branch=$(git branch | grep '^\* ' | grep -v 'no branch' | sed 's/^* //g')
Vincent Driessen68845232010-02-10 00:43:21 +010041 short_names=$(echo "$hotfix_branches" | sed "s ^$PREFIX g")
Vincent Driessen3c337fb2010-02-04 11:30:18 +010042
Vincent Driessen3c337fb2010-02-04 11:30:18 +010043 # determine column width first
Vincent Driessen27592dd2010-02-06 14:45:39 +010044 typeset -i width=0
45 typeset branch
46 for branch in $short_names; do
Vincent Driessenb673c442010-02-10 00:43:53 +010047 typeset -i len=${#branch}
Vincent Driessen3c337fb2010-02-04 11:30:18 +010048 width=$(max $width $len)
49 done
Vincent Driessen27592dd2010-02-06 14:45:39 +010050 width=width+3
Vincent Driessen3c337fb2010-02-04 11:30:18 +010051
Vincent Driessen27592dd2010-02-06 14:45:39 +010052 typeset branch
53 for branch in $short_names; do
Vincent Driessenc5fcc012010-02-10 00:18:08 +010054 typeset fullname=$PREFIX$branch
Vincent Driessen27592dd2010-02-06 14:45:39 +010055 typeset base=$(git merge-base "$fullname" "$MASTER_BRANCH")
56 typeset master_sha=$(git rev-parse "$MASTER_BRANCH")
57 typeset branch_sha=$(git rev-parse "$fullname")
58 if [ "$fullname" = "$current_branch" ]; then
Vincent Driessen3c337fb2010-02-04 11:30:18 +010059 printf "* "
60 else
61 printf " "
62 fi
63 if flag verbose; then
64 printf "%-${width}s" "$branch"
65 if [ "$branch_sha" = "$master_sha" ]; then
66 printf "(no commits yet)"
67 else
Vincent Driessena4dd2232010-02-10 00:34:59 +010068 typeset tagname=$(git name-rev --tags --no-undefined --name-only "$base")
Vincent Driessen27592dd2010-02-06 14:45:39 +010069 typeset nicename
Vincent Driessen3c337fb2010-02-04 11:30:18 +010070 if [ "$tagname" != "" ]; then
Vincent Driessenc5fcc012010-02-10 00:18:08 +010071 nicename=$tagname
Vincent Driessen3c337fb2010-02-04 11:30:18 +010072 else
Vincent Driessena4dd2232010-02-10 00:34:59 +010073 nicename=$(git rev-parse --short "$base")
Vincent Driessen3c337fb2010-02-04 11:30:18 +010074 fi
75 printf "(based on $nicename)"
76 fi
77 else
78 printf "%s" "$branch"
79 fi
80 echo
81 done
Vincent Driessen186d2b52010-01-27 23:48:39 +010082}
83
Benedikt Böhm00ccea62010-01-26 12:39:36 +010084cmd_help() {
85 usage
86 exit 0
87}
88
Vincent Driessenb866b012010-01-28 01:01:53 +010089parse_args() {
Vincent Driessen3c337fb2010-02-04 11:30:18 +010090 # parse options
91 FLAGS "$@" || exit $?
92 eval set -- "${FLAGS_ARGV}"
93
94 # read arguments into global variables
Vincent Driessenc5fcc012010-02-10 00:18:08 +010095 VERSION=$1
Vincent Driessen3c337fb2010-02-04 11:30:18 +010096 BRANCH=$PREFIX$VERSION
97}
98
99require_version_arg() {
Vincent Driessenb866b012010-01-28 01:01:53 +0100100 if [ "$VERSION" = "" ]; then
Vincent Driessen3c337fb2010-02-04 11:30:18 +0100101 warn "Missing argument <version>"
Vincent Driessenb866b012010-01-28 01:01:53 +0100102 usage
103 exit 1
104 fi
Vincent Driessenb866b012010-01-28 01:01:53 +0100105}
106
Vincent Driessen010252a2010-02-04 10:31:29 +0100107require_base_is_on_master() {
108 if ! git branch --contains "$BASE" 2>/dev/null \
109 | sed 's/[* ] //g' \
110 | grep -q "^$MASTER_BRANCH\$"; then
111 die "fatal: Given base '$BASE' is not a valid commit on '$MASTER_BRANCH'."
112 fi
113}
114
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100115cmd_start() {
Vincent Driessen1a2868b2010-02-07 23:23:16 +0100116 DEFINE_boolean fetch true "fetch from $ORIGIN before performing finish" F
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100117 parse_args "$@"
Vincent Driessenc5fcc012010-02-10 00:18:08 +0100118 BASE=${2:-$MASTER_BRANCH}
Vincent Driessen010252a2010-02-04 10:31:29 +0100119 require_version_arg
120 require_base_is_on_master
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100121
122 # sanity checks
Vincent Driessen48386442010-01-29 10:30:40 +0100123 gitflow_require_clean_working_tree
Vincent Driessena4dd2232010-02-10 00:34:59 +0100124 gitflow_require_branch_absent "$BRANCH"
125 gitflow_require_tag_absent "$VERSION_PREFIX$VERSION"
Vincent Driessenca73caf2010-02-07 19:46:38 +0100126 if flag fetch; then
Vincent Driessena4dd2232010-02-10 00:34:59 +0100127 git fetch -q "$ORIGIN" "$MASTER_BRANCH"
Vincent Driessen2acfffd2010-01-29 12:37:22 +0100128 fi
Vincent Driessena4dd2232010-02-10 00:34:59 +0100129 gitflow_require_branches_equal "$MASTER_BRANCH" "$ORIGIN/$MASTER_BRANCH"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100130
131 # create branch
Vincent Driessena4dd2232010-02-10 00:34:59 +0100132 git checkout -b "$BRANCH" "$BASE"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100133
134 echo
135 echo "Summary of actions:"
136 echo "- A new branch '$BRANCH' was created, based on '$BASE'"
137 echo "- You are now on branch '$BRANCH'"
138 echo
139 echo "Follow-up actions:"
140 echo "- Bump the version number now!"
141 echo "- Start committing your hot fixes"
142 echo "- When done, run:"
143 echo
Vincent Driessen010252a2010-02-04 10:31:29 +0100144 echo " git flow hotfix finish '$VERSION'"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100145 echo
146}
147
148cmd_finish() {
Vincent Driessen1a2868b2010-02-07 23:23:16 +0100149 DEFINE_boolean fetch true "fetch from $ORIGIN before performing finish" F
150 DEFINE_boolean sign false "sign the release tag cryptographically" s
151 DEFINE_string signingkey "" "use the given GPG-key for the digital signature (implies -s)" u
152 DEFINE_string message "" "use the given tag message" m
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100153 parse_args "$@"
Vincent Driessen010252a2010-02-04 10:31:29 +0100154 require_version_arg
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100155
Vincent Driessen1a2868b2010-02-07 23:23:16 +0100156 # handle flags that imply other flags
157 if [ "$FLAGS_signingkey" != "" ]; then
158 FLAGS_sign=$FLAGS_TRUE
159 fi
160
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100161 # sanity checks
Vincent Driessena4dd2232010-02-10 00:34:59 +0100162 gitflow_require_branch "$BRANCH"
Vincent Driessen48386442010-01-29 10:30:40 +0100163 gitflow_require_clean_working_tree
Vincent Driessenca73caf2010-02-07 19:46:38 +0100164 if flag fetch; then
Vincent Driessena4dd2232010-02-10 00:34:59 +0100165 git fetch -q "$ORIGIN" "$MASTER_BRANCH" || \
Vincent Driessen1a2868b2010-02-07 23:23:16 +0100166 die "Could not fetch $MASTER_BRANCH from $ORIGIN."
Vincent Driessena4dd2232010-02-10 00:34:59 +0100167 git fetch -q "$ORIGIN" "$DEVELOP_BRANCH" || \
Vincent Driessen1a2868b2010-02-07 23:23:16 +0100168 die "Could not fetch $DEVELOP_BRANCH from $ORIGIN."
Vincent Driessen2acfffd2010-01-29 12:37:22 +0100169 fi
Vincent Driessena4dd2232010-02-10 00:34:59 +0100170 gitflow_require_branches_equal "$MASTER_BRANCH" "$ORIGIN/$MASTER_BRANCH"
171 gitflow_require_branches_equal "$DEVELOP_BRANCH" "$ORIGIN/$DEVELOP_BRANCH"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100172
Vincent Driessen5fa47582010-02-09 00:31:33 +0100173 # try to merge into master
174 # in case a previous attempt to finish this release branch has failed,
175 # but the merge into master was successful, we skip it now
Vincent Driessena4dd2232010-02-10 00:34:59 +0100176 if ! gitflow_is_branch_merged_into "$BRANCH" "$MASTER_BRANCH"; then
177 git checkout "$MASTER_BRANCH" || \
Vincent Driessen5fa47582010-02-09 00:31:33 +0100178 die "Could not check out $MASTER_BRANCH."
Vincent Driessena4dd2232010-02-10 00:34:59 +0100179 git merge --no-ff "$BRANCH" || \
Vincent Driessen5fa47582010-02-09 00:31:33 +0100180 die "There were merge conflicts."
181 # TODO: What do we do now?
182 fi
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100183
Vincent Driessen5fa47582010-02-09 00:31:33 +0100184 # try to tag the release
185 # in case a previous attempt to finish this release branch has failed,
186 # but the tag was set successful, we skip it now
187 typeset tagname=$VERSION_PREFIX$VERSION
Vincent Driessena4dd2232010-02-10 00:34:59 +0100188 if ! gitflow_tag_exists "$tagname"; then
Vincent Driessen5fa47582010-02-09 00:31:33 +0100189 typeset opts="-a"
190 flag sign && opts="$opts -s"
191 [ "$FLAGS_signingkey" != "" ] && opts="$opts -u '$FLAGS_signingkey'"
192 [ "$FLAGS_message" != "" ] && opts="$opts -m '$FLAGS_message'"
193 git tag $opts "$VERSION_PREFIX$VERSION" || \
194 die "Tagging failed. Please run finish again to retry."
195 fi
Vincent Driessen1a2868b2010-02-07 23:23:16 +0100196
Vincent Driessen5fa47582010-02-09 00:31:33 +0100197 # try to merge into develop
198 # in case a previous attempt to finish this release branch has failed,
199 # but the merge into develop was successful, we skip it now
Vincent Driessena4dd2232010-02-10 00:34:59 +0100200 if ! gitflow_is_branch_merged_into "$BRANCH" "$DEVELOP_BRANCH"; then
201 git checkout "$DEVELOP_BRANCH" || \
Vincent Driessen5fa47582010-02-09 00:31:33 +0100202 die "Could not check out $DEVELOP_BRANCH."
203
Vincent Driessend29e3152010-02-09 00:55:06 +0100204 # TODO: Actually, accounting for 'git describe' pays, so we should
205 # ideally git merge --no-ff $tagname here, instead!
Vincent Driessena4dd2232010-02-10 00:34:59 +0100206 git merge --no-ff "$BRANCH" || \
Vincent Driessen5fa47582010-02-09 00:31:33 +0100207 die "There were merge conflicts."
208 # TODO: What do we do now?
209 fi
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100210
211 # delete branch
Vincent Driessena4dd2232010-02-10 00:34:59 +0100212 git branch -d "$BRANCH"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100213
214 # TODO: Implement an optional push to master
215 # git push origin develop; git push origin master; git push --tags origin
216
217 echo
218 echo "Summary of actions:"
Benedikt Böhm350e7152010-01-26 13:05:05 +0100219 echo "- Latest objects have been fetched from '$ORIGIN'"
Vincent Driessen010252a2010-02-04 10:31:29 +0100220 echo "- Hotfix branch has been merged into '$MASTER_BRANCH'"
Vincent Driessenab3dc492010-01-29 12:35:49 +0100221 echo "- The hotfix was tagged '$VERSION_PREFIX$VERSION'"
Vincent Driessen010252a2010-02-04 10:31:29 +0100222 echo "- Hotfix branch has been back-merged into '$DEVELOP_BRANCH'"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100223 echo "- Hotfix branch '$BRANCH' has been deleted"
224 echo
225}